function detektor()
%Program pro detekci plagiatu textovych dokumentu.
%Po spusteni se nacte graficke uzivatelske rozhrani.
%Pro porovnani lze pouzit pouze dokumenty ve formatu *.txt.
%Pro vyzkouseni funkce jsou vhodne soubory ze slozky Databaze_semestralka,
%jsou mnohem kratsi a rychle vyhodnocene v radu sekund, zaverecne prace se vyhodnoti v
%radu minut.

clear all;
close all;
clc;

function hlavniokno()
rozliseni_monitoru=get(0,'ScreenSize');
hlavni_okno=figure('Name','Detektor plagiatu',...
'NumberTitle','Off',...
'Color', [1 1 1],...
'Position',[0.25*(rozliseni_monitoru(3)),...
            0.45*(rozliseni_monitoru(4)),...
            800,600]);
%% %Prvky GUI
text_nahore=uicontrol('Parent',hlavni_okno,...
                          'Style','text',...
                          'String','Detektor plagiatu',...
                          'FontSize',30,...
                          'FontWeight', 'Bold',...
                          'Visible','on',...
                          'BackgroundColor',[1,1,1],...
                          'Units','pixels',...
                          'Position',[275,400,250,150],...
                          'Callback',@zacit_hru);
                      
text_prvni_soubor=uicontrol('Parent',hlavni_okno,...
                          'Style','text',...
                          'String','Prvni soubor: ',...
                          'FontSize',10,...
                          'FontWeight', 'Bold',...
                          'Visible','off',...
                          'BackgroundColor',[1,1,1],...
                          'Units','pixels',...
                          'Position',[275,100,250,150],...
                          'Callback',@zacit_hru);
text_vyber_dva_nebo_databaze=uicontrol('Parent',hlavni_okno,...
                          'Style','text',...
                          'String','Chcete porovnat dva soubory nebo soubor s databazi?',...
                          'FontSize',25,...
                          'Visible','on',...
                          'BackgroundColor',[1,1,1],...
                          'Units','pixels',...
                          'Position',[275,270,250,150],...
                          'Callback',@zacit_hru);
text_prvni_soubor_nazev=uicontrol('Parent',hlavni_okno,...
                          'Style','text',...
                          'String','Prvni soubor: ',...
                          'FontSize',10,...
                          'FontWeight', 'Bold',...
                          'Visible','off',...
                          'BackgroundColor',[1,1,1],...
                          'Units','pixels',...
                          'Position',[275,90,250,150],...
                          'Callback',@zacit_hru);
                      
text_vyber_prvni_soubor=uicontrol('Parent',hlavni_okno,...
                          'Style','text',...
                          'String','Vybrat prvni soubor',...
                          'FontSize',25,...
                          'Visible','off',...
                          'BackgroundColor',[1,1,1],...
                          'Units','pixels',...
                          'Position',[275,270,250,150],...
                          'Callback',@zacit_hru);
tlacitko_dva_soubory=uicontrol('Parent',hlavni_okno,...
                          'Style','pushbutton',...
                          'String','Dva soubory',...
                          'FontSize',20,...
                          'Visible','on',...
                          'BackgroundColor',[1,1,1],...
                          'Units','pixels',...
                          'Position',[190,280,200,50],...
                          'Callback',@dva_soubory);
tlacitko_databaze=uicontrol('Parent',hlavni_okno,...
                          'Style','pushbutton',...
                          'String','S databazi',...
                          'FontSize',20,...
                          'Visible','on',...
                          'BackgroundColor',[1,1,1],...
                          'Units','pixels',...
                          'Position',[410,280,200,50],...
                          'Callback',@databaaze);
tlacitko_vyber_prvni_soubor=uicontrol('Parent',hlavni_okno,...
                          'Style','pushbutton',...
                          'String','Kliknete pro vyber',...
                          'FontSize',20,...
                          'Visible','off',...
                          'BackgroundColor',[1,1,1],...
                          'Units','pixels',...
                          'Position',[295,320,200,50],...
                          'Callback',@nahrej_prvni_soubor);
tlacitko_vyber_druhy_soubor=uicontrol('Parent',hlavni_okno,...
                          'Style','pushbutton',...
                          'String','Kliknete pro vyber',...
                          'FontSize',20,...
                          'Visible','off',...
                          'BackgroundColor',[1,1,1],...
                          'Units','pixels',...
                          'Position',[295,320,200,50],...
                          'Callback',@nahrej_druhy_soubor);
tlacitko_vyber_slozku_databaze=uicontrol('Parent',hlavni_okno,...
                          'Style','pushbutton',...
                          'String','Kliknete pro vyber',...
                          'FontSize',20,...
                          'Visible','off',...
                          'BackgroundColor',[1,1,1],...
                          'Units','pixels',...
                          'Position',[295,320,200,50],...
                          'Callback',@nahrej_databazi);
tabulka_souboru=uicontrol('Parent',hlavni_okno,...
                          'Style','text',...
                          'String',{' ','Vysledky detekce:'},...
                          'FontSize',20,...
                          'Fontweight', 'bold',...
                          'Visible','off',...
                          'BackgroundColor',[0.9,0.9,0.9],...
                          'Units','pixels',...
                          'Position',[1,1,800,500],...
                          'Callback',@zacit_hru);
                      
tabulka_soubor1=uicontrol('Parent',hlavni_okno,...
                          'Style','text',...
                          'String',{'Nazev prvniho souboru:',' ',' ','Pocet vet:',' ',' ','Asymetricka podobnost 1:',' ',' ', 'Nejfrekventovanejsi slova:',' '},...
                          'HorizontalAlignment','left',...
                          'FontSize',15,...
                          'Visible','off',...
                          'BackgroundColor',[0.9,0.9,0.9],...
                          'Units','pixels',...
                          'Position',[145,1,250,450],...
                          'Callback',@zacit_hru);
tabulka_soubor2=uicontrol('Parent',hlavni_okno,...
                          'Style','text',...
                          'String',{'Nazev druheho souboru:',' ',' ','Pocet vet:',' ',' ','Asymetricka podobnost 2:',' ',' ', 'Nejfrekventovanejsi slova:',' '},...
                          'HorizontalAlignment','left',...
                          'FontSize',15,...
                          'Visible','off',...
                          'BackgroundColor',[0.9,0.9,0.9],...
                          'Units','pixels',...
                          'Position',[400,1,250,450],...
                          'Callback',@zacit_hru);
vysledky_databaze=uicontrol('Parent',hlavni_okno,...
                          'Style','text',...
                          'String',{'Plagiat [%]',' ',' ',' ',' ',' ',' ',' ',' ', ' ',' '},...
                          'HorizontalAlignment','left',...
                          'FontSize',15,...
                          'Visible','off',...
                          'BackgroundColor',[0.9,0.9,0.9],...
                          'Units','pixels',...
                          'Position',[720,1,80,467],...
                          'Callback',@zacit_hru);
tabulka_soubory_dohr=uicontrol('Parent',hlavni_okno,...
                          'Style','text',...
                          'String',{'Kosinova podobnost:',' ',' ','Pocet shodnych vet:',' '},...
                          'HorizontalAlignment','left',...
                          'FontSize',15,...
                          'Visible','off',...
                          'BackgroundColor',[0.9,0.9,0.9],...
                          'Units','pixels',...
                          'Position',[320,1,250,230],...
                          'Callback',@zacit_hru);
text_vsechny_nebo_zjistit=uicontrol('Parent',hlavni_okno,...
                          'Style','text',...
                          'String','Chcete porovnat s celou databazi nebo vybrat podobne?',...
                          'FontSize',25,...
                          'Visible','off',...
                          'BackgroundColor',[1,1,1],...
                          'Units','pixels',...
                          'Position',[1,1,800,100],...
                          'Callback',@zacit_hru);
tlacitko_porovnat_vsechny=uicontrol('Parent',hlavni_okno,...
                          'Style','pushbutton',...
                          'String','Vsechny',...
                          'FontSize',20,...
                          'Visible','off',...
                          'BackgroundColor',[1,1,1],...
                          'Units','pixels',...
                          'Position',[190,20,200,50],...
                          'Callback',@vsechny);
tlacitko_zjistit_ktere=uicontrol('Parent',hlavni_okno,...
                          'Style','pushbutton',...
                          'String','Jen podobne',...
                          'FontSize',20,...
                          'Visible','off',...
                          'BackgroundColor',[1,1,1],...
                          'Units','pixels',...
                          'Position',[410,20,200,50],...
                          'Callback',@zjistit);
vysledek_detekce=uicontrol('Parent',hlavni_okno,...
                          'Style','text',...
                          'String',{' ','Pravdepodobnost plagiatorstvi:','100%'},...
                          'FontSize',25,...
                          'Visible','off',...
                          'BackgroundColor',[1,1,1],...
                          'Units','pixels',...
                          'Position',[1,1,800,100],...
                          'Callback',@zacit_hru);

end
%% Funkce tlacitek GUI
function nahrej_prvni_soubor(~,~)
[nazev_souboru_1,cesta_k_souboru_1] = uigetfile('*.txt');
addpath(cesta_k_souboru_1)
%set(handles.text_vyber_prvni_soubor,'Visible','off')
uiresume(gcbf)
end

function nahrej_druhy_soubor(~,~)
[nazev_souboru_2,cesta_k_souboru_2] = uigetfile('*.txt');
addpath(cesta_k_souboru_2)
%set(handles.text_vyber_prvni_soubor,'Visible','off')
uiresume(gcbf)
end

function nahrej_databazi(~,~)
cesta_databaze = uigetdir(pwd, 'Select a folder');
dokumenty = dir(fullfile(cesta_databaze, '*.txt'));
vsechny_soubory = cell(1,size(dokumenty,1));
for i=1:1:size(dokumenty,1)
vsechny_soubory{i} = dokumenty(i).name;
end
addpath(cesta_databaze)
uiresume(gcbf)
end

function dva_soubory(~,~)
dva_soubory_pom = 0;
%set(handles.text_vyber_prvni_soubor,'Visible','off')
uiresume(gcbf)
end

function databaaze(~,~)
dva_soubory_pom = 1;
%set(handles.text_vyber_prvni_soubor,'Visible','off')
uiresume(gcbf)
end

function vsechny(~,~)
vsechny_pom = 1;
%set(handles.text_vyber_prvni_soubor,'Visible','off')
uiresume(gcbf)
end

function zjistit(~,~)
vsechny_pom = 0;
%set(handles.text_vyber_prvni_soubor,'Visible','off')
uiresume(gcbf)
end

%% %Hlavn skript
slCharacterEncoding('ISO-8859-2');
feature('DefaultCharacterSet', 'UTF8');
%Zdroj https://www.mathworks.com/matlabcentral/answers/112551-why-
%matlab-doesn-t-support-font-for-foreign-language-such-as-czech-
%for-example-the-character-e-s-c
clear ans;
%pause('on');
dva_soubory_pom = 0;
vsechny_pom = 0;
hlavniokno();
uiwait(gcf);
if dva_soubory_pom == 0
tlacitko_dva_soubory.Visible = 'Off';
tlacitko_databaze.Visible = 'Off';
text_vyber_dva_nebo_databaze.Visible = 'Off';
tlacitko_vyber_prvni_soubor.Visible = 'On';
text_vyber_prvni_soubor.Visible = 'On';
uiwait(gcf);
text_vyber_prvni_soubor.String = 'Vybrat druhy soubor';
tlacitko_vyber_prvni_soubor.Visible = 'Off';
tlacitko_vyber_druhy_soubor.Visible = 'On';
text_prvni_soubor_nazev.String = nazev_souboru_1;
text_prvni_soubor_nazev.Visible = 'On';
text_prvni_soubor.Visible = 'On';

uiwait(gcf);
tlacitko_vyber_druhy_soubor.Visible = 'Off';
text_vyber_prvni_soubor.Visible = 'Off';
text_prvni_soubor_nazev.Visible = 'Off';
text_prvni_soubor.Visible = 'Off';

%[asymetricka_podobnost1,asymetricka_podobnost2,kosinova_podobnost,NEJPOUZIVANEJSI_SLOVA_1,NEJPOUZIVANEJSI_SLOVA_2,pocet_shodnych_vet,pocet_vet_textu_1,pocet_vet_textu_2,VETY_V_OBOU] = porovnani_dvou_souboru(nazev_souboru_1,nazev_souboru_2);
[asymetricka_podobnost1,asymetricka_podobnost2,kosinova_podobnost,NEJPOUZIVANEJSI_SLOVA_1,NEJPOUZIVANEJSI_SLOVA_2,pocet_shodnych_vet,pocet_vet_textu_1,pocet_vet_textu_2] = porovnani_dvou_souboru(nazev_souboru_1,nazev_souboru_2);
tabulka_souboru.Visible = 'On';
text1 = nazev_souboru_1;
tabulka_soubor1.String{2} = text1;
text2 = nazev_souboru_2;
tabulka_soubor2.String{2} = text2;
tabulka_soubor1.String{5} = num2str(pocet_vet_textu_1);
tabulka_soubor2.String{5} = num2str(pocet_vet_textu_2);
tabulka_soubor1.String{8} = num2str(asymetricka_podobnost1);
tabulka_soubor2.String{8} = num2str(asymetricka_podobnost2);
retezec_nej_slov_1 = [];
for i=1:1:size(NEJPOUZIVANEJSI_SLOVA_1,1)
        retezec_nej_slov_1 = [retezec_nej_slov_1  NEJPOUZIVANEJSI_SLOVA_1{i,1}];
end
retezec_nej_slov_2 = [];
for i=1:1:size(NEJPOUZIVANEJSI_SLOVA_2,1)
        retezec_nej_slov_2 = [retezec_nej_slov_2  NEJPOUZIVANEJSI_SLOVA_2{i,1}];
end
tabulka_soubor1.String{11} = retezec_nej_slov_1;
tabulka_soubor2.String{11} = retezec_nej_slov_2;
tabulka_soubor1.Visible = 'On';
tabulka_soubor2.Visible = 'On';
tabulka_soubory_dohr.Visible = 'On';
tabulka_soubory_dohr.String{2} = num2str(kosinova_podobnost);
tabulka_soubory_dohr.String{5} = num2str(pocet_shodnych_vet);
tabulka_soubory_dohr.String{6} = ' ';
%Vypocet procenta pravdepodobnosti
if pocet_shodnych_vet > 0
    cislo_z_detektoru_vysledek = 100;
elseif kosinova_podobnost < 0.25 & asymetricka_podobnost1 < 0.25 & asymetricka_podobnost2 < 0.25
    cislo_z_detektoru_vysledek = 0;
else
    cislo_z_detektoru_vysledek = round(100*(kosinova_podobnost + asymetricka_podobnost1 + asymetricka_podobnost2)/3); 
end
vysledek_detekce.String{3} = [num2str(cislo_z_detektoru_vysledek),'%'];
vysledek_detekce.Visible = 'On';

elseif dva_soubory_pom == 1
tlacitko_dva_soubory.Visible = 'Off';
tlacitko_databaze.Visible = 'Off';
text_vyber_dva_nebo_databaze.Visible = 'Off';
tlacitko_vyber_prvni_soubor.Visible = 'On';
text_vyber_prvni_soubor.Visible = 'On';
uiwait(gcf);
text_vyber_prvni_soubor.String = 'Vybrat databazi';
tlacitko_vyber_prvni_soubor.Visible = 'Off';
tlacitko_vyber_slozku_databaze.Visible = 'On';
text_prvni_soubor_nazev.String = nazev_souboru_1;
text_prvni_soubor_nazev.Visible = 'On';
text_prvni_soubor.Visible = 'On';
uiwait(gcf);
tlacitko_vyber_slozku_databaze.Visible = 'Off';
text_vyber_prvni_soubor.Visible = 'Off';
text_prvni_soubor_nazev.Visible = 'Off';
text_prvni_soubor.Visible = 'Off';
tabulka_souboru.Visible = 'On';
tabulka_souboru.String = {' ','Databaze:'};
tabulka_soubor1.Visible = 'On';
tabulka_soubor2.Visible = 'On';
text1 = nazev_souboru_1;
tabulka_soubor1.String = {'Porovnavany soubor',' '};
tabulka_soubor1.String{2} = text1;
tabulka_soubor2.String = vsechny_soubory;
tlacitko_porovnat_vsechny.Visible = 'On';
tlacitko_zjistit_ktere.Visible = 'On';
text_vsechny_nebo_zjistit.Visible = 'On';
uiwait(gcf);

if vsechny_pom == 1
    [ vysledky ] = porovnani_souboru_s_databazi( nazev_souboru_1,vsechny_soubory );
    tlacitko_porovnat_vsechny.Visible = 'Off';
    tlacitko_zjistit_ktere.Visible = 'Off';
    text_vsechny_nebo_zjistit.Visible = 'Off';
    vysledky_databaze.Visible = 'On';
    for i=1:1:size(vsechny_soubory,2)
        vysledky_databaze.String{i+1} = vysledky{1,i}{9};
    end
    %save('output.mat','vysledky')
elseif vsechny_pom == 0
    [ vsechny_soubory ] = vybrani_podobnych( vsechny_soubory, nazev_souboru_1 );
    [ vysledky ] = porovnani_souboru_s_databazi( nazev_souboru_1,vsechny_soubory );
    tabulka_soubor2.String = vsechny_soubory;
    tlacitko_porovnat_vsechny.Visible = 'Off';
    tlacitko_zjistit_ktere.Visible = 'Off';
    text_vsechny_nebo_zjistit.Visible = 'Off';
    vysledky_databaze.Visible = 'On';
    for i=1:1:size(vsechny_soubory,2)
        vysledky_databaze.String{i+1} = vysledky{1,i}{9};
    end
end
end
end